﻿using System;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using TypedClientHttpClientFactoryReturningError.Models;

namespace TypedClientHttpClientFactoryReturningError.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class InvoiceController : ControllerBase
    {
        static int _getRequestCount = 0;

        [HttpGet("{orderId}")]
        public async Task<ActionResult> Get(int orderId)
        {
            await Task.Delay(100);// simulate some data by delaying for 100 milliseconds 
            _getRequestCount++;

            if (_getRequestCount % 2 == 0) // half the requests will succeed
            {
                return Ok(new Invoice(1000 + orderId) { Cost = 9.99m + orderId});
            }

            return StatusCode(StatusCodes.Status500InternalServerError, "Something went wrong while retrieving the invoice.");
        }
    }
}