﻿using System.Net.Http;
using System.Threading.Tasks;
using TypedClientHttpClientFactoryReturningError.Models;

namespace TypedClientHttpClientFactoryReturningError.TypedClients
{
    public class InvoiceClient
    {
        private readonly HttpClient _client;

        public InvoiceClient(HttpClient client)
        {
            _client = client;
        }

        public async Task<TypedResponse<Invoice>> GetInvoice(int orderId)
        {
            var response = await _client.GetAsync($"invoice/{orderId}");
            if (response.IsSuccessStatusCode)
            {
                Invoice invoice = await response.Content.ReadAsAsync<Invoice>();
                return new TypedResponse<Invoice> { Content = invoice, HttpStatusCode = response.StatusCode };
            }
            
            return new TypedResponse<Invoice>{ HttpStatusCode = response.StatusCode, Message = await response.Content.ReadAsStringAsync(), ReasonPhrase = response.ReasonPhrase };
        }
    }
}
